{ 021214a2.pas                                                              }
{ 2002-12-14 programmeerimisvistluse algajate 2. lesande lahendus         }
{    SUUSAVISTLUS                                                          }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'SUUS.SIS';
   valf = 'SUUS.VAL';
   maxn = 100;                                { maksimaalne suusatajate arv }

type
   kohad = record                   { suusatajate jrjekord hes ajapunktis }
      k : array [1..maxn] of integer;            { k[s] on suusataja s koht }
   end;
   tousvad = record                           { tusvalt sitnud suusatajad }
      t : array [1..maxn] of boolean;    { t[s] on false, kui s on langenud }
      n : integer;                             { seni tusvalt sitnute arv }
   end;

{ loeb suusatajate jrjestuse hes ajapunktis }
procedure loe_kohad (var f : text; var k : kohad; n : integer);
var i, s : integer;
begin
   for i := 1 to n do begin         { kik suusatajad saabumise jrjekorras }
      read(f, s);                                  { loeme suusataja numbri }
      k.k[s] := i;                                 { suusataja s on kohal i }
   end;
   readln(f);                             { liigume failis jrgmisele reale }
end;

{ seab algseisu: kski suusataja pole veel langenud }
procedure pane_tous (var t : tousvad; n : integer);
var s : integer;
begin
   for s := 1 to n do begin
      t.t[s] := true;                      { suusataja s pole veel langenud }
   end;
   t.n := n;                                  { kik on veel tsuvas joones }
end;

{ tmbab maha punktide k1 ja k2 vahel langenud suusatajad }
procedure kontrolli_tous (var t : tousvad; var k1, k2 : kohad; n : integer);
var s : integer;
begin
   for s := 1 to n do begin                 { kontrollime kiki suusatajaid }
      if t.t[s] then begin             { kui s on seni sitnud tusvalt ... }
         if k1.k[s] < k2.k[s] then begin           { ... ja nd langes ... }
            t.t[s] := false;              { ... siis pole s enam tusev ... }
            t.n := t.n - 1;         { ... ja tusvaid on ks vhem kui enne }
         end;
      end;
   end;
end;

{ vljastab tulemuse }
procedure valjasta_tous (var f : text; var t : tousvad; n : integer);
var s : integer; v : boolean;
begin
   writeln(f, t.n);                                 { tusvalt sitnute arv }
   v := false;                    { veel pole htegi suusatajat vljastatud }
   for s := 1 to n do begin                 { kontrollime kiki suusatajaid }
      if t.t[s] then begin                  { kui s on sitnud tusvalt ... }
         if v then begin               { kui s pole esimene vljastatav ... }
            write(f, ' ');           { ... siis eraldame eelmisest thikuga }
         end;
         write(f, s);                                        { vljastame s }
         v := true;                            { nd on midagi vljastatud }
      end;
   end;
   writeln(f);                                               { lpetame rea }
end;

var
   f : text;                                           { sisend/vljundfail }
   n : integer;                                           { suusatajate arv }
   m : integer;                                           { ajapunktide arv }
   i : integer;                                     { abimuutuja kordusteks }
   k1, k2 : kohad;                       { jrjestus kahes viimases punktis }
   t : tousvad;                               { tusvalt sitvad suusatajad }

begin
   assign(f, sisf); reset(f);                { avame sisendfaili lugemiseks }
   readln(f, n, m);                 { loeme suusatajate ja ajapunktide arvu }
   pane_tous(t, n);                      { alguses pole veel keegi langenud }
   for i := 1 to m do begin                      { ttleme kik ajapunktid }
      loe_kohad(f, k2, n);                   { loeme suusatajate jrjestuse }
      if i > 1 then begin               { kui see pole esimene ajapunkt ... }
         kontrolli_tous(t, k1, k2, n);        { ... siis vrdleme eelmisega }
      end;
      k1 := k2;                         { nd on see juba eelmine ajapunkt }
   end;
   close(f);                                          { sulgeme sisendfaili }

   assign(f, valf); rewrite(f);          { avame vljundfaili kirjutamiseks }
   valjasta_tous(f, t, n);                           { vljastame tulemused }
   close(f);                                         { sulgeme vljundfaili }
end.
