{
    Programmeerimisolympiaadi koolivoor.    14.12.2002.
    Algajate ryhm.

    Naidislahendus.
    Ylesanne:
           A4 "BMAT"

    Autor: Andrei Solntsev
           drusha@ut.ee

    Programmeerimiskeel:
           Borland Pascal 7.0
}

const
     sisf : string = 'BMAT.SIS';
     valf : string = 'BMAT.VAL';

type
       Bit_Maatriks = array [1..8, 1..8] of boolean;
       Num_Maatriks = array [1..8] of integer;
       {
        Maatriksi bitt-esitus:
        massiivi element [i, j] on true, kui maatriksis
        kohal [i, j] asub 1, ja false, kui 0.

        Maatriksi reaesitus:
        vt. ylesande pystitust.
       }

var
     b_mat : Bit_Maatriks;    { Antud bitimaatriks bitt-esituses  }
     n_mat : Num_Maatriks;    { Antud bitimaatriks reaesituses    }


{
    Protseduuride ja funktsioonide definitsioonid
}

procedure readData;
{
   protseduur readData
      loeb failist 'BMAT.SIS' 8 taisarvu -
      mingi bitimaatriksi reaesituse.
}
var
    f: text;
    i: integer;
begin
  assign (f, sisf);
  reset (f);
  for i := 1 to 8 do
    readln (f, n_mat[i]);
  close (f);
end;

procedure writeData;
{
   protseduur writeData
   1. loob uue faili 'BMAT.VAL'.
   2. kirjutab sinna saadud bitimaatriksi reaesituse.
}
var
    f : text;
    i : integer;
begin
  assign (f, valf);
  rewrite (f);
  for i := 1 to 8 do
    writeln (f, n_mat[i]);
  close (f);
end;



procedure NumToBit;
{
   protseduur NumToBit
   Sisse:
     massiiv n_mat  - mingi bitimaatriksi reaesitus
   Valja:
     massiiv b_mat  - selle bitimaatriksi bitt-esitus
}
var
      i, j : integer;
begin
  for i := 1 to 8 do
    for j := 8 downto 1 do
      begin

      {
        (kahend)Arvu viimane bitt on vqrdne yhega parajasti siis,
        kui see (kymnend)arv on paaritu.
      }
      b_mat [i, j] := odd(n_mat[i]);

      {
        Kqik bitid liiguvad paremale yhe positsiooni vqrra.
        Siinjuures eelviimane bitt muutub viimaseks.
        See tehe kannab nimetust "nihe".
      }
      n_mat[i] := n_mat[i] div 2;
      end;
end;





procedure BitToNum;
{
   protseduur BitToNum
   Sisse:
     massiiv b_mat  - mingi bitimaatriksi bitt-esitus
   Valja:
     massiiv n_mat  - selle bitimaatriksi reaesitus

   Too printsiip:
   Nagu teada, arvu kymnendsysteemist kahendsysteemisse viimise
   algoritm on selline:
   ARV_10  :=   sum (2^i), kus i on kqik kohad, kus kahendarvus asub 1.
   Naiteks:
      kahendarv = 100101  (yhed asuvad kohtadel 0., 2., ja 5.)
      kymnendarv := 2^0 + 2^2 + 2^5 = 1+4+32 = 37.

}
var
     i, j, pow2 : integer;
begin
  for i := 1 to 8 do
    begin
    n_mat[i] := 0;
    pow2 := 1;
    for j := 8 downto 1 do
      begin
      {
        tsykli invariant:  pow2   =   2 astmes (8-j)
      }

      {
        Kui bitimaatriksis kohal [i, j] asub 1 (vastavalt true),
        siis liidame kymnendarvule 2 astmes (8-j).
      }
      if (b_mat[i,j]) then inc (n_mat[i], pow2);
      pow2 := pow2 * 2;
      end;
    end;
end;





procedure printMat;
{
  Protseduur printMat.
  Sisse:
     bitimaatriks bitt-esituses.
  Valja:
    protseduur valjastab seda maatriksi ekraanile.

  Tegelikult seda protseduuri pole lahenduses vaja,
  seda vqib lihtsalt kasutada silumisel.
}
var
     i, j : integer;
begin
  for i := 1 to 8 do
    begin
    for j := 1 to 8 do
      if (b_mat[i,j]) then write ('1 ') else write ('0 ');
    writeln;
    end;
writeln;
end;





procedure Transp_Maatriks;
{
  Protseduur Transp_Maatriks.
  Sisse:
     mingi maatriks bitt-esituses.
  Valja:
     transponeeritud maatriks.

  Protseduur transponeerib antud maatriksi.
  Algoritm on vaga lihtne:
    * iga element [i, j] mis asub peadiagonaali kohal
      poolel (s.t. kus i>j), vahetab koha elemendiga [j, i].
    * elemendid peadiagonaalil (st. kus i=j) jaavad
      oma kohtadele.
}
var
     i, j : integer;
     abi :  boolean;
begin
  for i := 1 to 8 do
    for j := i+1 to 8 do
        begin
        {
          Elemendid [i, j] ja [j, i] vahetavad kohad
        }
        abi := b_mat[i, j];
        b_mat[i, j] := b_mat[j, i];
        b_mat[j, i] := abi;
        end;
end;


BEGIN
  {
    1. Loeme maatriksi reaesituse
    2. Transleerime selle bitt-esituseks
    3. Transponeerime
    4. Transleerime saadud maatriksi reaesituseks.
    5. Valjastame tulemuse
  }
  readData;
  NumToBit; {printMat;}
  Transp_Maatriks; {printMat;}
  BitToNum;
  writeData;
END.
