{
    Programmeerimisolympiaadi koolivoor.    14.12.2002.
    Edasijqudnute ryhm.

    Naidislahendus.
    Ylesanne:
           E1 "ORIENT"

    Autor: Andrei Solntsev
           drusha@ut.ee

    Programeerimiskeel:
           Borland Pascal 7.0
}

const
     sisf : string = 'ORIENT.SIS';
     valf : string = 'ORIENT.VAL';

type
     massiiv20 = array[1..20] of integer;
     massiiv50 = array[1..50] of integer;

var
   N, K : integer;
   kohustuslikud : massiiv20;  {nqutud marsruut  - maksimaalselt 20 punkti}
   labitud       : massiiv50;  {labitud marsruut - maksimaalselt 50 punkti}


{
    Protseduuride ja funktsioonide loetelu
    readData    - loeb andmed failist
    writeData   - kirjutab vastuse faili
    oigesti     - kontrollib, kas osaleja labis raja oigesti
    kasOigesti  - abifunktsioon, vt. selle definitsioon
}
procedure readData; forward;
procedure writeData (vastus : string); forward;
function kasOige (i, j :integer) : boolean; forward;
function oigesti : boolean; forward;




{
    Protseduuride ja funktsioonide definitsioonid
}
procedure readData;
{
   protseduur readData
      loeb failist 'ORIENT.SIS' jargmised andmed:
      N K
      k1 k2 ... kN     --> massiiv kohustuslikud
      l1 l2 ... lK     --> massiiv labitud
}
var
     f : text;
     i : integer;
begin
  assign (f, sisf);       {Nyyd f on seotud failga 'ORIENT.SIS'}
  reset (f);              {Avame selle faili}
    readln (f, N, K);     {loeme esimesest reas kaks arvu: N ja K}
    for i:=1 to N do
      read (f, kohustuslikud[i]); { tsyklis loeme teisest reast }
                                  { massiivi kohustsuslikud[]   }
    readln(f);

    for i:=1 to K do
      read (f, labitud[i]);       { tsyklis loeme kolmandast reast }
                                  { massiivi labitud[]             }
  close(f);
end;



procedure writeData (vastus: string);
{
   protseduur writeData
   sisse:
      sqne vastus
   valja:
      1) loob uue faili 'ORIENT.VAL'.
      2) kirjutab selle faili ainsale reale sqne vastus.
}
var
       f : text;
begin
  assign (f, valf);      { Nyyd f on seotud failiga 'ORIENT.VAL' }
  rewrite (f);           { Loome see faili                       }
    writeln (f, vastus); { Kirjutame sinna sqne vastus           }
  close (f);             { Paneme faili kinni                    }
end;






function oigesti : boolean;
{
   funktsioon oigesti
   sisse:
      N, K, massiivid kohustuslikud[1..N] ja labitud[1..K]
   valja:
      kontrollib, kas osaleja labis raja oigesti.
      Tagastab vastavalt true (qigesti) vqi false (valesti).
}
var
     i : integer;
begin
  {
    Esimeseks kontrollime, et massiivide esimesed ja
    viimased punktid yhtivad.
  }
  if ( (kohustuslikud[1] <> labitud[1]) or
       (kohustuslikud[N] <> labitud[K]) )  then
                         begin
                         oigesti := false;
                         exit;
                         end;

  {
     Teiseks kontrollime, et
     start ja finish oleks labitud ainult yks kord.
  }
  for i:=2 to K-1 do
    if (labitud[i] = labitud[1])  or  (labitud[i] = labitud[K]) then
                    begin
                    oigesti := false;
                    exit;
                    end;

  {
      Kolmandaks kaivitame abifunktsiooni kasOige,
    mis hakkab kontrollima, kas osaleja marsruut on oige,
    alates antud elementidest.
      Seda, et esimesed elemendid yhtivad, me oleme juba kontrollinud,
    seetqttu hakame vordlema kaks massiivi alatest teistest
    elementidest.
  }
  oigesti := kasOige (2, 2);

end;





function kasOige (i, j : integer) : boolean;
{
   abifunktsioon kasOige
   sisse:
      N, K, massiivid kohustuslikud[1..N] ja labitud[1..K]
      kaks indeksit: i ja j.
   valja:
      kontrollib, kas osaleja labis raja oigesti.
      Tapsemalt, kas antud kaks massiivi "yhtivad" ehk
      kas kehtib tingimus
          kohustsulikud  =  labitud (miinus moned elemendid)

     NB! Funktsioon algab kontrollimist
        i.ndast elemendist massiivis kohustsuslikud[]
      ning
        j.ndast elemendist massiivis labitud[].

     See on rekursiivne funktsioon, mis
     korduvalt kaivitab iseennast kuni massiivi lqpuni.
}
begin
  {
      Eeltingimus: antud kahe massiivi alammassiivid "yhtivad":
      kohustsulikud[1..i-1]  =  labitud [1..j-1]
                                (miinus moned elemendid)
      j >= i
  }

  {
    Kui mqlemad indeksid laksid piiridest valja yheaegselt,
    siis see tahendab, et massiivid "yhtivad".
  }
  if (i>N) and (j>K) then
    begin
    kasOige := true;
    exit;
    end;

  {
    Kui ainult yks indeks laks valja,
    siis see tahendab, et massiivid "ei yhti".
  }
  if (i>N) or (j>K) then
    begin
    kasOige := false;
    exit;
    end;

  {
    !!!   SEE ON KOGU PROGRAMMI PEAMINE KOHT  !!!
    Kui jooksvad elemendid on vqrdsed
        (naiteks nii:       i=j=2
                            5 7 4
                            5 7 6 4
        )
    , siis me vqrdleme kaht massiivi edasi
    alates elementidest number i+1   ja   j+1.

    Kui jooksvad elemendid ei ole vqrdsed
        (naiteks nii:     i=j=3
                          5 7 4
                          5 7 6 4
        )
    , siis me vqrdleme kaht massiivi edasi
    alates elementidest number i ja j+1.

    Selleks et vqrrelda kaht massiivi edasi,
    funktsioon kasutabki rekursiivselt iseend.
  }
  if (kohustuslikud[i] = labitud[j]) then
    kasOige := kasOige (i+1, j+1)
  else
    kasOige := kasOige (i, j+1);
end;



BEGIN
  readData;
  if (oigesti) then
    writeData ('JAH')
  else
    writeData ('EI');
END.
