{ 021214e2.pas                                                              }
{ 2002-12-14 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{    MURDJOON                                                               }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'MURD.SIS';
   valf = 'MURD.VAL';
   maxn = 10;                                     { maksimaalne tippude arv }

type
   punkt = record                                     { punkti koordinaadid }
      x, y : real;
   end;
   vektor = punkt;                        { vektor on tegelikult samasugune }

{ kontrollib, kas arv on piisavalt vike, et lugeda ta nulliks }
function null (x : real) : boolean;
begin
   null := (abs(x) < 1e-6);
end;

{ kontrollib, kas kaks punkti langevad kokku }
function sama (p1, p2 : punkt) : boolean;
begin
   sama := (null(p2.x - p1.x) and null(p2.y - p1.y));
end;

{ teeb vektori p1->p2 }
procedure vekt (p1, p2 : punkt; var v : vektor);
begin
   v.x := p2.x - p1.x; v.y := p2.y - p1.y;
end;

{ arvutab vektori pikkuse }
function pikk (v : vektor) : real;
begin
   pikk := sqrt(sqr(v.x) + sqr(v.y));
end;

{ arvutab kahe vektori skalaarkorrutise }
function skorr (v1, v2 : vektor) : real;
begin
   skorr := v1.x * v2.x - v1.y * v2.y;
end;

{ arvutab kahe vektori vektorkorrutise (pikkuse (koos mrgiga)) }
function vkorr (v1, v2 : vektor) : real;
begin
   vkorr := v1.x * v2.y - v1.y * v2.x;
end;

{ kontrollib, kas p jb p1->p2 suunast vasakule vi paremale }
{ tagastab: +1 - vasakule, 0 - otse, -1 - paremale }
function suund (p1, p2, p : punkt) : integer;
var v, vv : vektor; x : real;
begin
   vekt(p1, p2, v); vekt(p1, p, vv);
   x := vkorr(v, vv);
   if null(x) then
      suund := 0
   else if x > 0 then
      suund := +1
   else
      suund := -1;
end;

{ kontrollib, kas ligud a1-a2 ja b1-b2 likuvad }
{ kui likuvad, arvutab likepunkti muutujasse q }
{ kui on hine lik, arvutab selle keskpunkti muutujasse q }
function loik (a1, a2, b1, b2 : punkt; var q : punkt) : boolean;
var va, vb, v : vektor; r, r1, r2 : real;
begin
   vekt(a1, a2, va); vekt(b1, b2, vb); r := vkorr(va, vb);
   if null(r) then begin
      { ligud on samasihilised }
      if (suund(a1, a2, b1) = 0) and (suund(a1, a2, b2) = 0) then begin
         { ligud on hel sirgel }
         vekt(a1, b1, v); r1 := skorr(va, v) / sqr(pikk(va));
         vekt(a1, b2, v); r2 := skorr(va, v) / sqr(pikk(va));
{writeln('hel sirgel ', r1, ' ', r2);}
         if (r1 < 0) and (r2 < 0) then begin
            { b1 ja b2 on mlemad a1 "taga" }
            loik := false;
         end else if (r1 > 1) and (r2 > 1) then begin
            { b1 ja b2 on mlemad a2 "taga" }
            loik := false;
         end else begin
            { leiame a ja b hisosa }
            if r1 < 0 then r1 := 0;
            if r1 > 1 then r1 := 1;
            if r2 < 0 then r2 := 0;
            if r2 > 1 then r2 := 1;
            { leiame hisosa keskmise punkti koordinaadid }
            q.x := a1.x + (r1 + r2) / 2 * va.x;
            q.y := a1.y + (r1 + r2) / 2 * va.y;
{writeln('q = ', q.x, ' ', q.y);}
            loik := true;
         end;
      end else begin
         { ligud on erinevatel paralleelsetel sirgetel }
{writeln('paralleelsetel sirgetel');}
         loik := false;
      end;
   end else begin
      { ligud on erisihilised }
      vekt(a1, b1, v);
      r1 := vkorr(v, vb) / r;
      r2 := vkorr(v, va) / r;
{writeln('likuvatel sirgetel ', r1, ' ', r2);}
      if (r1 < 0) or (r1 > 1) then begin
         { sirgete likepunkt on vljaspool a1-a2 }
         loik := false;
      end else if (r2 < 0) or (r2 > 1) then begin
         { sirgete likepunkt on vljaspool b1-b2 }
         loik := false;
      end else begin
         { leiame likepunkti koordinaadid }
         q.x := a1.x + r1 * va.x;
         q.y := a1.y + r1 * va.y;
{writeln('q = ', q.x, ' ', q.y);}
         loik := true;
      end;
   end;
end;

var
   f : text;                                           { sisend/vljundfail }
   n : integer;                                              { punktide arv }
   p : array [1..maxn] of punkt;                              { punktid ise }
   l : boolean;                                         { kas on likumine? }
   q, qq : punkt;                             { likepunktid, kui on olemas }
   i, j : integer;                             { abimuutujad korduste jaoks }

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, p[i].x, p[i].y);
   close(f);

   { arvutame tulemuse }
   l := false;                                   { seni veel pole likumisi }
   for i := 1 to n - 1 do                      { vaatleme like p[i]-p[i+1] }
      for j := i + 1 to n - 1 do               { vaatleme like p[j]-p[j+1] }
begin
{writeln(i, ' ', j);}
         if loik(p[i], p[i + 1], p[j], p[j + 1], q) then     { kui likuvad }
            { likumine lheb likumisena arvesse ainult siis, }
            { kui see pole jrjestikuste likude hine otspunkt }
            if (j > i + 1) or not sama (p[i + 1], q) then begin
               l := true; qq := q;
{writeln('salvestan q');}
            end;
end;

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   if l then begin
      writeln(f, 'JAH');
      writeln(f, qq.x :0:2, ' ', qq.y :0:2);
   end else
      writeln(f, 'EI');
   close(f);
end.
