{ kontroll.pas                                                              }
{ 2002-12-14 programmeerimisvistluse edasijudnute 3. lesande tester      }
{    KODEERITUD LIITMINE                                                    }
{ Ahto Truu                                                                 }

{$I+}

const
   maxn = 10;                                     { maksimaalne tippude arv }

type
   punkt = record                                     { punkti koordinaadid }
      x, y : real;
   end;
   vektor = punkt;                        { vektor on tegelikult samasugune }

{ kontrollib, kas arv on piisavalt vike, et lugeda ta nulliks }
function null (x : real) : boolean;
begin
   null := (abs(x) < 1e-6);
end;

{ kontrollib, kas kaks punkti langevad kokku }
function sama (p1, p2 : punkt) : boolean;
begin
   sama := (null(p2.x - p1.x) and null(p2.y - p1.y));
end;

{ teeb vektori p1->p2 }
procedure vekt (p1, p2 : punkt; var v : vektor);
begin
   v.x := p2.x - p1.x; v.y := p2.y - p1.y;
end;

{ arvutab vektori pikkuse }
function pikk (v : vektor) : real;
begin
   pikk := sqrt(sqr(v.x) + sqr(v.y));
end;

{ arvutab kahe vektori skalaarkorrutise }
function skorr (v1, v2 : vektor) : real;
begin
   skorr := v1.x * v2.x - v1.y * v2.y;
end;

{ arvutab kahe vektori vektorkorrutise (pikkuse (koos mrgiga)) }
function vkorr (v1, v2 : vektor) : real;
begin
   vkorr := v1.x * v2.y - v1.y * v2.x;
end;

{ kontrollib, kas p asub ligul a1-a2 }
function loigul (a1, a2, p : punkt) : boolean;
var va, v : vektor; r, r1, r2 : real;
begin
   vekt(a1, a2, va); vekt(a1, p, v);
   r1 := vkorr(va, v); r2 := skorr(va, v) / sqr(pikk(va));
   loigul := not(not null(r1) or (r2 < 0) or (r2 > 1));
end;

var
   f : text;                                           { sisend/vljundfail }
   n : integer;                                              { punktide arv }
   p : array [1..maxn] of punkt;                              { punktid ise }
   s1, s2 : string;                                     { vastused (jah/ei) }
   q : punkt;                                             { lahendaja punkt }
   l : integer;                                            { likumiste arv }
   i : integer;                                 { abimuutuja korduste jaoks }

begin
   if paramcount <> 3 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail nidisfail vljundfail');
      halt(1);
   end;

   { loeme sisendandmed }
   assign(f, paramstr(1)); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, p[i].x, p[i].y);
   close(f);

   { loeme ige vastuse }
   assign(f, paramstr(2)); reset(f);
   readln(f, s1);
   close(f);

   { loeme vljundandmed }
   assign(f, paramstr(3)); reset(f);
   readln(f, s2);
   if s2 = 'JAH' then begin
      if seekeof(f) then begin
         writeln('Punkt puudub');
         halt(1);
      end;
      readln(f, q.x, q.y);
   end;
   if not seekeof(f) then
      writeln('Liigsed smbolid faili lpus');
   close(f);

   { kontrollime vastused }
   if s1 = s2 then
      writeln('Vastus ', s2, ' ige')
   else
      writeln('Vastus ', s2, ' vale, peaks olema ', s1);

   { kontrollime punkti }
   if s2 = 'JAH' then begin
      l := 0;
      for i := 2 to n - 1 do
         if sama(p[i], q) then
            l := -1;
      for i := 1 to n - 1 do
         if loigul(p[i], p[i + 1], q) then
            l := l + 1;
      if l < 2 then
         writeln('Punkt ', q.x, ' ', q.y, ' vale')
      else
         writeln('Punkt ige');
   end;
end.
